Attribute VB_Name = "VerstuurEmails"
Public GekozenAfzender As String

Sub VerstuurConcepten()
    Dim frm As Object
    Dim olMail As Outlook.MailItem
    Dim xSelection As Selection
    Dim xPromptStr As String
    Dim xZenderAangpast As String
    Dim xYesOrNo As Integer
    Dim xCount As Integer
    Dim i As Long
    Dim xArr() As String
    Dim xAccount As Account
    Dim xCurFld As Folder
    Dim xDraftsFld As Folder
    Dim xTmpFld As Folder
    Dim xMail As MailItem
    Dim Item As Object
    Dim acc As Outlook.Account
    Dim afzenderAccount As Outlook.Account

    If Application.ActiveExplorer.Selection.Count = 0 Then
        MsgBox "Selecteer eerst conceptmails in Outlook.", vbExclamation
        Exit Sub
    End If

    ' Toon formulier
    Set frm = New AfzenderForm
    frm.Show

    If GekozenAfzender = "" Then
        MsgBox "Actie geannuleerd.", vbExclamation
        Exit Sub
    End If

    ' Zoek bijbehorende account
    For Each acc In Application.Session.Accounts
        If LCase(acc.SmtpAddress) = LCase(GekozenAfzender) Then
            Set afzenderAccount = acc
            Exit For
        End If
    Next

    If afzenderAccount Is Nothing Then
        MsgBox "Afzenderaccount niet gevonden in Outlook.", vbCritical
        Exit Sub
    End If

    ' Valideer dat we in een conceptmap zitten
    Set xTmpFld = Nothing
    Set xCurFld = Application.ActiveExplorer.CurrentFolder
    For Each xAccount In Outlook.Application.Session.Accounts
        On Error Resume Next
        Set xDraftsFld = xAccount.DeliveryStore.GetDefaultFolder(olFolderDrafts)
        On Error GoTo 0

        If Not xDraftsFld Is Nothing Then
            If xDraftsFld.entryID = xCurFld.entryID Then
                Set xTmpFld = xCurFld.Parent
                Exit For
            End If
        End If
    Next xAccount

    If xTmpFld Is Nothing Then
        MsgBox "De huidige map is geen conceptenmap.", vbInformation
        Exit Sub
    End If

    ' Verzamel EntryIDs en pas afzenderaccount toe
    Set xSelection = Application.ActiveExplorer.Selection
    ReDim xArr(xSelection.Count - 1)
    xCount = 0

    If LCase(GekozenAfzender) <> LCase(Application.Session.Accounts(1).SmtpAddress) Then
        ' Pas afzender aan vr verzenden
        xZenderAangpast = " aangepaste"
        For i = 1 To xSelection.Count
            Set Item = xSelection.Item(i)
            If TypeOf Item Is MailItem Then
                If Item.Parent.DefaultItemType = olMailItem And Item.Sent = False Then
                    Set olMail = Item
                    If Not olMail.Sent Then
                        On Error Resume Next
                        If olMail.Saved = False Then olMail.Save
                        olMail.Close olDiscard
                        DoEvents
                        On Error GoTo 0

                        Dim tempEntryID As String
                        tempEntryID = olMail.entryID
                        Set olMail = Nothing
                        DoEvents
                        Set olMail = Application.Session.GetItemFromID(tempEntryID)

                        Dim t#
                        t = Timer
                        Do While Timer < t + 0.2
                            DoEvents
                        Loop

                        On Error Resume Next
                        olMail.SendUsingAccount = afzenderAccount
                        On Error GoTo 0

                        olMail.Save
                        xArr(i - 1) = olMail.entryID
                    End If
                End If
            End If
        Next
    Else
        xZenderAangpast = ""
        For i = 1 To xSelection.Count
            Set Item = xSelection.Item(i)
            If TypeOf Item Is MailItem Then
                If Item.Parent.DefaultItemType = olMailItem And Item.Sent = False Then
                    xArr(i - 1) = xSelection.Item(i).entryID
                End If
            End If
        Next
    End If

    xPromptStr = "Wil je de " & xSelection.Count & xZenderAangpast & " conceptmail(s) nu verzenden?"
    xYesOrNo = MsgBox(xPromptStr, vbQuestion + vbYesNo, "Verzenden?")
    If xYesOrNo <> vbYes Then Exit Sub

    Set Application.ActiveExplorer.CurrentFolder = xTmpFld
    VBA.DoEvents

    For i = 0 To UBound(xArr)
        If xArr(i) <> "" Then
            Dim entryID As String
            entryID = xArr(i)
    
            ' Heropen het item vers
            On Error Resume Next
            Set xMail = Application.Session.GetItemFromID(entryID)
            On Error GoTo 0
            DoEvents
    
            If Not xMail Is Nothing Then
                If xMail.Recipients.Count <> 0 Then
                    ' Final save + resend
                    On Error Resume Next
                    If xMail.Saved = False Then xMail.Save
                    DoEvents
                    Set xMail = Nothing
                    Set xMail = Application.Session.GetItemFromID(entryID)
                    xMail.Save
                    xMail.Send
                    On Error GoTo 0
                    xCount = xCount + 1
                End If
            End If
        End If
    Next


    VBA.DoEvents
    Set Application.ActiveExplorer.CurrentFolder = xCurFld

    MsgBox "Succesvol verzonden: " & xCount & " mail(s).", vbInformation, "Outlook"
End Sub

